//*******************************************************
//	FM channel Radio  mini Version
//	FM tuner module : NS953M (NIIGATA SEIMITSU CO., LTD.)
//
//	MCU:	ATmega88
//			efuse:F9h
//			hfuse:D6h	BOD 1.8V
//			lfuse:62h	内蔵CR 1MHz EEPROM保護
//
//	Compiler:	AVR-GCC		4.2.2
//				AVR-LIBC	1.4.7
//				binutils	2.18
//
//	2008.8.21	KAWAKAMI Yukio
//*******************************************************

#define		NOP		asm volatile("nop\n"::)
#define		WDR		asm volatile("wdr\n"::)
#define		SLEEP	asm volatile("sleep\n"::)

typedef	unsigned char	uchar;
typedef	unsigned int	uint;
typedef	unsigned short	ushort;
typedef	unsigned long	ulong;

// ポート設定
#define		PB7			7	// PORTB
#define		PB6			6
#define		SCK			5
#define		MISO		4
#define		MOSI		3
#define		AMP_POWER	2
#define		P8			1
#define		POWER_LOCK	0

#define		P7			7	// PORTD
#define		P6			6
#define		P5			5
#define		P4			4
#define		P3			3
#define		P2			2
#define		P1			1
#define		P0			0

#define		POWER_SW	2	// PORTD

#define		SCL			5	// PORTC
#define		SDA			4
#define		PC3			3
#define		PC2			2
#define		PC1			1
#define		PC0			0

#define		ADC7		7

#define		EEPROM_CH			1	// チャンネル番号保存アドレス
#define		EEPROM_STEREO_FLAG	2	// ステレオ動作フラグ
#define		EEPROM_FREQ_START	8	// 周波数プリセット値の開始アドレス

#define		SW_POWER	0x01
#define		SW_1		0x02
#define		SW_2		0x04
#define		SW_3		0x08
#define		SW_4		0x10

char	TWI_open(void);
char	TWI_start(void);
char	TWI_write(uchar data);
uchar	TWI_read_ack(void);
uchar	TWI_read_nack(void);
void	TWI_close(void);

uint	get_freq(uchar ch);
void	set_freq(uint freq);

uchar	check_freq(uint freq);
void	write_NS953M(uchar adrs, uchar data);
uchar	read_NS953M(uchar adrs);

void	scan_wave(void);
void	power_off(void);
